﻿using NLog;
using System;
using System.Diagnostics;
using System.Runtime.CompilerServices;

namespace Wicture.DbRESTFul
{
    public static class LoggerManager
    {
        public static ILogger Logger { get; private set; }

        static LoggerManager()
        {
            Logger = LogManager.GetLogger("DbRESTFul");
        }

        public static Stopwatch StartWatch([CallerMemberName] string targetName = "")
        {
            Logger.Debug($"`{targetName}`: Start watching at: {DateTime.Now}");
            return Stopwatch.StartNew();
        }

        public static void LogWatch(Stopwatch sw, string message, [CallerMemberName] string targetName = "")
        {
            Logger.Debug($"`{targetName}`: {message} at: {DateTime.Now}, toke: {sw.ElapsedMilliseconds}ms");
        }

        public static void EndWatch(Stopwatch sw, [CallerMemberName] string targetName = "")
        {
            Logger.Debug($"`{targetName}`: End watching at: {DateTime.Now}, toke: {sw.ElapsedMilliseconds}ms");
            sw.Stop();
        }
    }
}
